Index: trunk/NEMOGCM/TOOLS/GRIDGEN/src/types.f90
===================================================================
--- trunk/NEMOGCM/TOOLS/GRIDGEN/src/types.f90	(revision 2528)
+++ trunk/NEMOGCM/TOOLS/GRIDGEN/src/types.f90	(revision 2528)
@@ -0,0 +1,210 @@
+MODULE types
+  !
+  PUBLIC
+  !   
+  !*****************************
+  ! Coordinates type definition 
+  !*****************************
+  TYPE coordinates
+     REAL*8, DIMENSION(:,:), POINTER  :: nav_lon,nav_lat              => NULL()
+     REAL*8, DIMENSION(:,:), POINTER  :: glamv, glamu, glamt, glamf   => NULL()
+     REAL*8, DIMENSION(:,:), POINTER  :: gphit, gphiu, gphiv, gphif   => NULL()
+     REAL*8, DIMENSION(:,:), POINTER  :: e1t, e1u, e1v, e1f           => NULL()
+     REAL*8, DIMENSION(:,:), POINTER  :: e2t, e2u, e2v, e2f           => NULL()
+     INTEGER, DIMENSION(:) , POINTER  :: time_steps                   => NULL()
+  END TYPE coordinates
+  !
+  !
+  !
+  TYPE mixed_coordinates
+     REAL*8, DIMENSION(:,:), POINTER  :: nav_lon,nav_lat              => NULL()
+     REAL*8, DIMENSION(:,:), POINTER  :: glam                         => NULL()
+     REAL*8, DIMENSION(:,:), POINTER  :: gphi                         => NULL()
+     REAL*8, DIMENSION(:,:), POINTER  :: e1                           => NULL()
+     REAL*8, DIMENSION(:,:), POINTER  :: e2                           => NULL()
+     INTEGER, DIMENSION(:) , POINTER  :: time_steps                   => NULL()
+  END TYPE mixed_coordinates
+  !
+  !**************************************************************
+  ! Declaration of global variables
+  !**************************************************************
+  !size of input ORCA grid
+  INTEGER :: nsizex, nsizey    
+  INTEGER :: nmid            
+  !
+  !kind of input grid
+  INTEGER :: npivot 
+  !
+  INTEGER :: nequator
+  !
+  LOGICAL :: nglobal
+  !
+  INTEGER :: nresx, nresy
+  !
+  !distance between middle of input grid and the border of sub-domain 
+  INTEGER :: nval1, nval2
+  !
+  INTEGER :: nxcoag, nycoag     !size of the sub-domain inside input ORCA grid 
+  INTEGER :: nxgmix, nygmix     !size of the mixed grid 
+  INTEGER :: nxfine, nyfine     !size of fine grid 
+  !
+  TYPE(coordinates), SAVE :: scoagrd         !coarse grid
+  TYPE(coordinates), SAVE :: sfingrd         !fine grid
+  TYPE(mixed_coordinates), SAVE :: smixgrd   !mixed grid to store all components (T,U,V,F) 
+  !                                           of the coarse grid in the same one
+  !
+  !
+  !
+  !**************************************************************
+  ! Declaration of various input file variables (namelist.input) 
+  !**************************************************************
+  INTEGER nn_imin,nn_jmin,nn_imax,nn_jmax,nn_rhox,nn_rhoy
+  LOGICAL ln_iom_activated
+  CHARACTER*100 cn_parent_coordinate_file, cn_position_pivot
+  !      
+  NAMELIST /input_output/ln_iom_activated
+  NAMELIST /coarse_grid_files/cn_parent_coordinate_file,cn_position_pivot
+  NAMELIST /nesting/nn_imin,nn_jmin,nn_imax,nn_jmax,nn_rhox,nn_rhoy      
+  !
+  !
+  !
+CONTAINS
+  !********************************************************
+  !             subroutine grid_allocate				*
+  !					                            		*
+  !         allocation of grid type elements 			*
+  !             according to nx and ny	     			*
+  !							                            *
+  !********************************************************
+  SUBROUTINE grid_allocate(Grid,nx,ny)
+    !
+    TYPE(coordinates) :: Grid
+    INTEGER :: nx,ny
+    !
+    ALLOCATE(Grid%nav_lon(nx,ny),Grid%nav_lat(nx,ny))
+    ALLOCATE(Grid%glamt(nx,ny),Grid%glamu(nx,ny),Grid%glamv(nx,ny),Grid%glamf(nx,ny))
+    ALLOCATE(Grid%gphit(nx,ny),Grid%gphiu(nx,ny),Grid%gphiv(nx,ny),Grid%gphif(nx,ny))
+    ALLOCATE(Grid%e1t(nx,ny),Grid%e1u(nx,ny),Grid%e1v(nx,ny),Grid%e1f(nx,ny))
+    ALLOCATE(Grid%e2t(nx,ny),Grid%e2u(nx,ny),Grid%e2v(nx,ny),Grid%e2f(nx,ny))
+	!
+  END SUBROUTINE grid_allocate
+  !
+  !
+  !
+  SUBROUTINE grid_deallocate(Grid)
+    !
+    TYPE(coordinates) :: Grid
+    !
+    DEALLOCATE(Grid%nav_lon,Grid%nav_lat)
+    DEALLOCATE(Grid%glamt,Grid%glamu,Grid%glamv,Grid%glamf)
+    DEALLOCATE(Grid%gphit,Grid%gphiu,Grid%gphiv,Grid%gphif)
+    DEALLOCATE(Grid%e1t,Grid%e1u,Grid%e1v,Grid%e1f)
+    DEALLOCATE(Grid%e2t,Grid%e2u,Grid%e2v,Grid%e2f)
+	!
+  END SUBROUTINE grid_deallocate
+  !
+  !
+  !
+  !********************************************************
+  !           subroutine mixed_grid_allocate			*
+  !							                            *
+  !          allocation of grid type elements 			*
+  !               according to nx and ny				*
+  !						                            	*
+  !********************************************************
+  SUBROUTINE mixed_grid_allocate(Grid,nx,ny)
+    !
+    TYPE(mixed_coordinates) :: Grid
+    INTEGER :: nx,ny
+    !
+    ALLOCATE(Grid%nav_lon(nx,ny),Grid%nav_lat(nx,ny))
+    ALLOCATE(Grid%glam(nx,ny))
+    ALLOCATE(Grid%gphi(nx,ny))
+    ALLOCATE(Grid%e1(nx,ny))
+    ALLOCATE(Grid%e2(nx,ny))
+	!
+  END SUBROUTINE mixed_grid_allocate
+  !
+  !
+  !
+  SUBROUTINE mixed_grid_deallocate(Grid)
+    !
+    TYPE(mixed_coordinates) :: Grid
+    !
+    DEALLOCATE(Grid%nav_lon,Grid%nav_lat)
+    DEALLOCATE(Grid%glam)
+    DEALLOCATE(Grid%gphi)
+    DEALLOCATE(Grid%e1)
+    DEALLOCATE(Grid%e2)
+	!
+  END SUBROUTINE mixed_grid_deallocate
+  !
+  !
+  !
+  !********************************************************
+  !             subroutine read_namelist				*
+  !				                     					*
+  !   read variables contained in namelist.input file   *
+  !                filled in by user 					*
+  !								                    	*
+  !********************************************************
+  SUBROUTINE read_namelist(namelistname)
+    !
+    IMPLICIT NONE
+    CHARACTER(len=80) :: namelistname
+    CHARACTER*255 :: output
+    LOGICAL :: is_it_there
+    INTEGER unit_nml
+    !
+    unit_nml = Get_Unit()
+    !      
+    INQUIRE ( FILE = namelistname , EXIST = is_it_there )      
+    !
+    IF ( is_it_there ) THEN 
+       !
+       OPEN ( FILE   =  namelistname, &
+              UNIT   =  unit_nml,	  &
+              STATUS = 'OLD',		  &
+              FORM   = 'FORMATTED',	  &
+              ACTION = 'READ',		  &
+              ACCESS = 'SEQUENTIAL'     )	  
+       !
+       REWIND(unit_nml)
+       READ (unit_nml , NML = coarse_grid_files)
+       READ (unit_nml , NML = nesting) 
+       CLOSE(unit_nml)
+	   !
+    ELSE
+       !
+       PRINT *,'namelist file ''',TRIM(namelistname),''' not found'
+       STOP	 
+       !
+    END IF
+    !
+  END SUBROUTINE read_namelist
+  !
+  !
+  !
+  !*************************************************
+  !              function Get_Unit                             
+  !*************************************************
+  INTEGER FUNCTION Get_Unit()
+    !
+    INTEGER n
+    LOGICAL op
+    INTEGER :: nunit
+    INTEGER :: iii,out,iiimax 
+    ! 
+    DO n = 7,1000
+       ! 
+       INQUIRE(Unit=n,Opened=op)
+       !
+       IF (.NOT.op) EXIT
+       !      
+    ENDDO
+    !
+    Get_Unit=n
+    !
+  END FUNCTION Get_Unit
+  !
+END MODULE types
Index: trunk/NEMOGCM/TOOLS/MISCELLANEOUS/chk_iomput.sh
===================================================================
--- trunk/NEMOGCM/TOOLS/MISCELLANEOUS/chk_iomput.sh	(revision 2528)
+++ trunk/NEMOGCM/TOOLS/MISCELLANEOUS/chk_iomput.sh	(revision 2528)
@@ -0,0 +1,130 @@
+#!/bin/bash
+#------------------------------------------------
+#$Id$
+#------------------------------------------------
+#
+set -u
+#
+# if not argument -> get the help
+[ $# -eq 0 ] && ./$0 --help && exit
+#
+inxml=0
+insrc=0
+while [ $# -gt 0 ]   # Until you run out of parameters . . . 
+do    
+    case "$1" in 
+	-h|--help)
+	    echo
+	    echo 'Description:'
+	    echo '      check that an xml file is coherant with the source code:'
+	    echo '         - all variable ids defined by "call iom_put" must have their counterpart'
+	    echo '           in the variable definition in xml file'
+	    echo '         - list variable ids defined in xml file without any corresponding call'
+	    echo '           to iom_put. This can be done but it is useless as iom will only ouput zeros'
+	    echo '         - all variable ids used in the files definition in xml file must have'
+	    echo '           their counterpart in the variable definition in xml file'
+	    echo 'Usage:'
+	    echo '      chk_iomput.sh [OPTION]'
+	    echo '  or  chk_iomput.sh [OPTION] xmlfile DIRECTORIES'
+	    echo '         with:'
+	    echo '           xmlfile:  the xml file to test'
+	    echo '           DIRECTORIES: a list of directories containing the source code'
+	    echo 'Options'
+	    echo ' -h, --help           to get this help'
+	    echo ' --inxml              only print all variable definitions found in the xml file'
+	    echo ' --insrc              only print all variable definitions found in the source code'
+	    echo 'Examples'
+	    echo '      chk_iomput.sh'
+	    echo '      chk_iomput.sh --help'
+	    echo '      chk_iomput.sh ../../CONFIG/ORCA2_LIM/EXP00/iodef.xml "../../NEMO/OPA_SRC/ ../../NEMO/LIM_SRC_2/"'
+	    echo
+	    exit ;;
+        --inxml) inxml=1 ;;
+        --insrc) insrc=1 ;;
+	-*) echo ; echo "illegal option" ; ./$0 --help && exit ;;
+	*) [ $# -ne 2 ] && echo && echo "wrong number of arguments" && ./$0 --help && exit
+	    xmlfile=${1}
+	    srcdir=${2}
+	   shift
+    esac
+    shift       # Check next set of parameters. 
+done 
+#
+[ ! -f "$xmlfile" ] && echo "$xmlfile not found, we stop..." && exit
+for i in $srcdir 
+do
+    [ ! -d $i ] && echo "$i is not a directory, we stop..." && exit
+done
+#
+#------------------------------------------------
+#
+[ $inxml -eq 1 ] && grep "< *field * id *=" $xmlfile
+[ $insrc -eq 1 ] && find $srcdir -name "*.[Ffh]90" -exec grep -iH "^[^\!]*call  *iom_put *(" {} \;
+[ $(( $insrc + $inxml )) -ge 1 ] && exit
+#
+#------------------------------------------------
+#
+# list of file containing "CALL iom_put" in $srcdir
+#
+srclist=$( find $srcdir -name "*.[Ffh]90" -exec grep -il "^[^\!]*call  *iom_put *(" {} \; )
+#
+# list of variables used in "CALL iom_put"
+#
+varlistsrc=$( find $srcdir -name "*.[Ffh]90" -exec grep -i  "^[^\!]*call  *iom_put *(" {} \; | sed -e "s/.*iom_put *( *[\"\']\([^\"\']*\)[\"\'] *,.*/\1/" | sort -d )
+#
+# list of variables defined in the xml file
+#
+varlistxml=$( grep "< *field * id *=" $xmlfile  | sed -e "s/^.*< *field * id *= *[\"\']\([^\"\']*\)[\"\'].*/\1/" | sort -d )
+#
+# list of variables to be outputed in the xml file
+#
+varlistout=$( grep "< *field * ref *=" $xmlfile  | sed -e "s/^.*< *field * ref *= *[\"\']\([^\"\']*\)[\"\'].*/\1/" | sort -d )
+#
+echo "--------------------------------------------------"
+echo  check if all iom_put found in $srcdir
+echo  have a corresponding variable definition in $xmlfile
+echo "--------------------------------------------------"
+for var in $varlistsrc
+do
+    tst=$( echo " "$varlistxml" " | grep -c " $var " )
+    if [ $tst -ne 1 ] 
+    then
+	echo "problem with $var: $tst lines corresponding to its definition in $xmlfile, but defined in the code in"
+	for f in $srclist
+	do
+	    grep -iH "^[^\!]*call  *iom_put *( *[\"\']${var}[\"\'] *," $f
+	done
+	echo
+    fi
+done
+#
+echo "--------------------------------------------------"
+echo  check if all variables defined in $xmlfile
+echo  have a corresponding \"call iom_put\" in sources found in $srcdir
+echo "--------------------------------------------------"
+#
+for var in $varlistxml
+do
+    found=$( echo " "$varlistsrc" " | grep -c " $var " )
+    if [ $found -eq 0 ] 
+    then
+	echo \"call iom_put\" not found for variable $var
+	grep "< *field * id *= *[\"\']${var}[\"\']" $xmlfile
+	echo
+    fi
+done
+#
+echo "--------------------------------------------------"
+echo  ${xmlfile}: check if all variables to be outputed in files are really defined...
+echo "--------------------------------------------------"
+#
+# list of variables defined in the xml file
+for var in $varlistout
+do
+    found=$( echo " "$varlistxml" " | grep -c " $var " )
+    [ $found -eq 0 ] && echo variable to be outputed but not defined: $var 
+done
+
+
+
+exit
Index: trunk/NEMOGCM/TOOLS/MPP_PREP/namelist
===================================================================
--- trunk/NEMOGCM/TOOLS/MPP_PREP/namelist	(revision 2528)
+++ trunk/NEMOGCM/TOOLS/MPP_PREP/namelist	(revision 2528)
@@ -0,0 +1,75 @@
+!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+!  MPP_OPTIMIZ_ZOOM namelist
+! ---------------------------
+!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+!
+!'''''''''''''''''''''''''''''''''''''''''
+!       namspace  spatial indexes
+!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+! NAMELIST /namspace/ jpiglo,jpjglo,jpidta,jpjdta,nizoom,njzoom
+! jpiglo = overall size of the zoomed region (i-direction)
+! jpjglo = overall size of the zoomed region (j-direction)
+! jpidta = overall size of the domain (i-direction)
+! jpjdta = overall size of the domain (j-direction)
+! nizoom = i -index of point (1,1) of the zoomed region/ jpidta
+! njzoom = j -index of point (1,1) of the zoomed region/ jpjdta
+!
+&NAMSPACE
+    jpk=31
+    jpiglo =  182
+    jpjglo =  149
+    jpidta =  182
+    jpjdta =  149
+    nizoom = 1
+    njzoom = 1
+/
+!'''''''''''''''''''''''''''''''''''''
+!      namproc
+!''''''''''''''''''''''''''''''''''''
+!   jprocx = maximum number of proc
+!   jpmem = 0 : dont care about the use of memory
+!           1 : try to optimize the use of memory
+!
+&NAMPROC
+     jprocx= 80
+     jpmem = 0
+/
+!''''''''''''''''''''''''''''''''''''''
+!      namparam
+!''''''''''''''''''''''''''''''''''''''
+!  ppmcal = memoire en octet d'un processeur
+!  ppmin = ??
+!  ppmax = ??
+!
+&NAMPARAM
+   ppmcal = 225000000.
+   ppmin = 0.4
+   ppmax = 0.9
+/
+!
+!'''''''''''''''''''''''''''''''''''''''
+!      namfile  of filename
+!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+! NAMELIST /namfile/ cbathy
+! cbathy = name of the  bathymetric file(nc)
+! ln_zps = false if bathy file is level
+!          true  if bathy file is meter
+!
+&NAMFILE
+     cbathy='bathymetry_depth_ORCA_R2_V3.nc'
+     ln_zps=.true.
+/
+!
+!''''''''''''''''''''''''''''''''''''''
+!      namkeep  jpni jpnj  kept
+!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+! NAMELIST /namkeep/ jpni,jpnj,covdta
+!   jpni = number of procs. in the i-direction
+!   jpnj = number of procs. in the j-direction
+!   covdta = Root for the overdata file name .
+!           Complete name will be {covdta}.{jpni}x{jpnj}_{jpnij}
+&NAMKEEP
+    jpni = 7
+    jpnj =11 
+    covdta = 'ORCA2-zahir'
+/
Index: trunk/NEMOGCM/TOOLS/MPP_PREP/src/mpp_optimiz_zoom_nc.f90
===================================================================
--- trunk/NEMOGCM/TOOLS/MPP_PREP/src/mpp_optimiz_zoom_nc.f90	(revision 2528)
+++ trunk/NEMOGCM/TOOLS/MPP_PREP/src/mpp_optimiz_zoom_nc.f90	(revision 2528)
@@ -0,0 +1,372 @@
+PROGRAM mpp_optimiz_nc
+ !!---------------------------------------------------------------------
+ !!
+ !!                       PROGRAM MPP_OPTIMIZ_NC
+ !!                     ***********************
+ !!
+ !!  PURPOSE :
+ !!  ---------
+ !!              This program is build to optimize the domain beakdown into
+ !!              subdomain for mpp computing.
+ !!              Once the grid size, and the land/sea mask is known, it looks
+ !!              for all the possibilities within a range of setting parameters
+ !!              and determine the optimal.
+ !!
+ !!              Optimization is done with respect to the maximum number of
+ !!              sea processors and to the maximum numbers of procs (jprocx)
+ !!                     
+ !!              Optional optimization can be performed takink into account
+ !!              the maximum available processor memory ppmcal. This is
+ !!              activated if jpmen =1
+ !!
+ !! history:
+ !! --------
+ !!       original  : 95-12 (Imbard M) for OPA8.1, CLIPPER
+ !!       f90       : 03-06 (Molines JM), namelist as input
+ !!                 : 05-05 (Molines JM), bathy in ncdf
+ !!----------------------------------------------------------------------
+ !! * modules used
+  USE netcdf
+
+  IMPLICIT NONE
+
+  INTEGER ::  jprocx=250   !: maximum number of proc. (Read from namelist)
+  INTEGER ::  jpmem=0      !: memory constraint (1) or no constraint (0)
+     !                     !  (use 1 with caution as the memory size of 
+     !                     !   the code lays on OPA 8.1 estimates ...)
+     !
+  INTEGER          ::  &
+       jpk    = 46  ,    & !: vertical levels (namelist)
+       jpiglo = 1442,    & !: I-size of the model (namelist)
+       jpjglo = 1021,    & !: J-size of the model (namelist)
+       jpidta = 1442,    & !: I-size of the data file (namelist)
+       jpjdta = 1021,   &  !: J-size of the data files (namelist)
+       nizoom = 1 ,     &  !: I zoom indicator (namelist)
+       njzoom = 1 ,     &  !: J zoom indicatori (namelist)
+       numnam = 4          !: logical unit for the namelist
+  NAMELIST /namspace/ jpk,jpiglo,jpjglo,jpidta,jpjdta,nizoom,njzoom
+  NAMELIST /namproc/ jprocx, jpmem
+
+  INTEGER ::  jpnix ,jpnjx  
+  !
+  INTEGER,PARAMETER :: jpreci=1 ,jprecj=1
+  !
+  ! Following variables are used only if jpmem=1
+  REAL(KIND=4) ::  ppmpt ,   &
+       ppmcal = 225000000., &  !: maximum memory of one processor for a given machine (in 8 byte words)
+       ppmin  = 0.4,         & !: minimum ratio to fill the memory
+       ppmax  = 0.9            !: maximum ration to fill the memory
+  ! Aleph
+  !     PARAMETER(ppmcal= 16000000.)
+  !Brodie
+  !     PARAMETER(ppmcal=250000000.)
+  ! Uqbar
+  !     PARAMETER(ppmcal=3750000000.)
+  ! Zahir
+  !     PARAMETER(ppmcal=225000000.)
+
+  CHARACTER(LEN=80) :: cbathy, &       !: File name of the netcdf bathymetry (namelist)
+      &                clvar           !: Variable name in netcdf for the bathy to be read
+  LOGICAL ::  ln_zps=.false.           !: Logical flag for partial cells.
+  NAMELIST /namfile/ cbathy, ln_zps
+  NAMELIST /namparam/ ppmcal, ppmin, ppmax
+  !
+  INTEGER :: iumout = 1
+  INTEGER :: ji,jj,jn,jni,jnj,jni2,jnj2
+  INTEGER :: iumbat,ifreq,il1,il2
+  INTEGER :: ii,iim,ij,ijm,imoy,iost,iresti,irestj,isurf,ivide
+  INTEGER :: iilb,ijlb,ireci,irecj,in
+  INTEGER :: ipi,ipj
+  INTEGER :: inf10,inf30,inf50,iptx,isw
+  INTEGER :: iii,iij,iiii,iijj,iimoy,iinf10,iinf30,iinf50
+  !
+  INTEGER,DIMENSION(:,:),ALLOCATABLE     ::  ibathy    ! jpidta -jpjdta
+  INTEGER,DIMENSION(:,:),ALLOCATABLE     ::  ippdi, ippdj ,iidom, ijdom
+  !
+  REAL(KIND=4)                           ::  zmin,zmax,zper,zmem
+  REAL(KIND=4)                           ::  zzmin,zzmax,zperx
+  REAL(KIND=4),DIMENSION(:,:),ALLOCATABLE  ::  zmask ,&  ! jpiglo -jpjglo
+      &                                        zdta      ! jpidta -jpjdta
+
+ ! CDF stuff
+  INTEGER :: ncid, ivarid, istatus
+  LOGICAL ::  llbon=.false.
+  !
+  ! 0. Initialisation
+  ! -----------------
+  OPEN(numnam,FILE='namelist')
+  REWIND(numnam)
+  READ(numnam,namspace)
+
+  REWIND(numnam)
+  READ(numnam,namfile)
+
+  REWIND(numnam)
+  READ(numnam,namparam)
+
+  REWIND(numnam)
+  READ(numnam,namproc)
+
+  ! estimated  code size expressed in number of 3D arrays (valid for OPA8.1)
+  ppmpt = 55.+73./jpk
+  jpnix = jprocx ; jpnjx=jprocx
+
+  ALLOCATE ( ibathy(jpidta,jpjdta), zmask(jpiglo,jpjglo),zdta(jpidta,jpjdta) )
+  ALLOCATE (ippdi(jpnix,jpnjx), ippdj(jpnix,jpnjx) )
+  ALLOCATE (iidom(jpnix,jpnjx), ijdom(jpnix,jpnjx) )
+
+  OPEN(iumout,FILE='processor.layout')
+  WRITE(iumout,*)
+  WRITE(iumout,*) ' optimisation de la partition'
+  WRITE(iumout,*) ' ----------------------------'
+  WRITE(iumout,*)
+  !
+  ! * Read cdf bathy file
+  !
+         IF ( ln_zps ) THEN        ! partial steps
+            clvar = 'Bathymetry'
+         ELSE 
+            clvar = 'Bathy_level'  ! full steps
+         ENDIF
+
+         INQUIRE( FILE=cbathy, EXIST=llbon )
+      IF( llbon ) THEN
+            istatus=NF90_OPEN(cbathy,NF90_NOWRITE,ncid)
+            istatus=NF90_INQ_VARID(ncid,clvar,ivarid)
+            istatus=NF90_GET_VAR(ncid,ivarid,zdta)
+            istatus=NF90_CLOSE(ncid)
+      ELSE
+          PRINT *,' File missing : ', trim(cbathy)
+          STOP
+      ENDIF
+  ibathy(:,:)=zdta(:,:)
+
+  !
+  ! Building the mask
+  DO jj=1,jpjglo
+     DO ji=1,jpiglo
+        zmask(ji,jj) = float(ibathy(ji+nizoom - 1,jj+njzoom -1))
+     END DO
+  END DO
+
+  DO jj=1,jpjglo
+     DO ji=1,jpiglo
+        zmask(ji,jj)=  min(REAL(1.,kind=4),max(REAL(0.,kind=4),zmask(ji,jj)))  ! Old vector coding rule ...
+     END DO
+  END DO
+  !
+  !  Main loop on processors
+  ! ------------------------
+  iii=1 ; iij=1
+  iiii=jpiglo ; iijj=jpjglo
+  iptx=0
+  iimoy=0
+  zzmin=0. ; zzmax=0.
+  iinf10=0 ; iinf30=0 ; iinf50=0
+  zperx=1.
+  in=0
+  DO jni=1,jpnix
+     DO jnj=1,jpnjx
+        !
+        ! Limitation ob the maxumun number of PE's
+        IF(jni*jnj >  jprocx) goto 1000
+        !
+        ! Partition
+        ipi=(jpiglo-2*jpreci + (jni-1))/jni + 2*jpreci
+        ipj=(jpjglo-2*jprecj + (jnj-1))/jnj + 2*jprecj
+        !
+        ! Memory optimization ?
+        isw=0
+        zmem=ppmpt*ipi*ipj*jpk
+        IF(zmem > ppmcal) go to 1000
+        IF(jpmem == 1) THEN
+           IF(zmem.GT.ppmax*ppmcal.OR.zmem.LT.ppmin*ppmcal) isw=1
+        ENDIF
+        IF(isw.EQ.1) go to 1000
+        in=in+1
+        !
+        WRITE(iumout,*) '--> nombre de processeurs ',jni*jnj
+        WRITE(iumout,*) ' '
+        WRITE(iumout,*) " jpni=",jni ," jpnj=",jnj
+        WRITE(iumout,*) " jpi= ",ipi ," jpj= ",ipj
+        zper=(jni*jnj*ipi*ipj)/float(jpiglo*jpjglo)
+        WRITE(iumout,*) " rapport jpnij*domain/global domain ",zper
+        !
+        ! Coin en bas a gauche de chaque processeur
+        !
+        iilb=1
+        ijlb=1
+        ireci=2*jpreci
+        irecj=2*jprecj
+        iresti = MOD ( jpiglo - ireci , jni )
+        irestj = MOD ( jpjglo - irecj , jnj )
+        !
+        IF (iresti.EQ.0) iresti = jni
+        DO jj=1,jnj
+           DO ji=1,iresti
+              ippdi(ji,jj) = ipi
+           END DO
+           DO ji=iresti+1,jni
+              ippdi(ji,jj) = ipi -1
+           END DO
+        END DO
+        IF (irestj.EQ.0) irestj = jnj
+        DO ji=1,jni
+           DO jj=1,irestj
+              ippdj(ji,jj) = ipj
+           END DO
+           DO jj=irestj+1,jnj
+              ippdj(ji,jj) = ipj -1
+           END DO
+        END DO
+        DO jj=1,jnj
+           DO ji=1,jni
+              iidom(ji,jj)=iilb
+              ijdom(ji,jj)=ijlb
+           END DO
+        END DO
+        WRITE(iumout,*) " iresti=",iresti," irestj=",irestj
+        !
+        !  2. Boucle sur les processeurs
+        ! ------------------------------
+        !
+        ivide=0
+        imoy=0
+        zmin=1.e+20
+        zmax=-1.e+20
+        inf10=0
+        inf30=0
+        inf50=0
+        !
+        DO jni2=1,jni
+           DO jnj2=1,jnj
+
+              IF(jni.GT.1)THEN
+                 DO jj=1,jnj
+                    DO ji=2,jni
+                       iidom(ji,jj)=iidom(ji-1,jj)+ippdi(ji-1,jj)-ireci
+                    END DO
+                 END DO
+                 iilb=iidom(jni2,jnj2)
+              ENDIF
+              IF(jnj.GT.1)THEN
+                 DO jj=2,jnj
+                    DO ji=1,jni
+                       ijdom(ji,jj)=ijdom(ji,jj-1)+ippdj(ji,jj-1)-irecj
+                    END DO
+                 END DO
+                 ijlb=ijdom(jni2,jnj2)
+              ENDIF
+              isurf=0
+              DO jj=1+jprecj,ippdj(jni2,jnj2)-jprecj
+                 DO  ji=1+jpreci,ippdi(jni2,jnj2)-jpreci
+                    IF(zmask(ji+iilb-1,jj+ijlb-1).EQ.1.) isurf=isurf+1
+                 END DO
+              END DO
+              IF(isurf.EQ.0) THEN
+                 ivide=ivide+1
+              ELSE
+                 imoy=imoy+isurf
+              ENDIF
+              zper=float(isurf)/float(ipi*ipj)
+              IF(zmin.GT.zper.AND.isurf.NE.0) zmin=zper
+              IF(zmax.LT.zper.AND.isurf.NE.0) zmax=zper
+              IF(zper.LT.0.1.AND.isurf.NE.0) inf10=inf10+1
+              IF(zper.LT.0.3.AND.isurf.NE.0) inf30=inf30+1
+              IF(zper.LT.0.5.AND.isurf.NE.0) inf50=inf50+1
+              !
+              !
+              ! 3. Fin de boucle sur les processeurs, impression
+              ! ------------------------------------------------
+              !
+           END DO
+        END DO
+        WRITE(iumout,*) ' nombre de processeurs       ',jni*jnj
+        WRITE(iumout,*) ' nombre de processeurs mer   ',jni*jnj-ivide
+        WRITE(iumout,*) ' nombre de processeurs terre ',ivide
+        WRITE(iumout,*) ' moyenne de recouvrement     ',float(imoy)/float(jni*jnj-ivide)/float(ipi*ipj)
+        WRITE(iumout,*) ' minimum de recouvrement     ',zmin
+        WRITE(iumout,*) ' maximum de recouvrement     ',zmax
+        WRITE(iumout,*) ' nb de p recouvrement < 10 % ',inf10
+        WRITE(iumout,*) ' nb de p      10 < nb < 30 % ',inf30-inf10
+        WRITE(iumout,*) ' nb de p      30 < nb < 50 % ',inf50-inf10 -inf30
+        WRITE(iumout,*) ' nombre de points integres   ', (jni*jnj-ivide)*ipi*ipj
+        WRITE(iumout,*) ' nbr de pts supplementaires  ', (jni*jnj-ivide)*ipi*ipj-jpiglo*jpjglo
+        zper=float((jni*jnj-ivide))*float(ipi*ipj)/float(jpiglo*jpjglo)
+        WRITE(iumout,*) ' % sup                       ',zper
+        WRITE(iumout,*)
+        ! 
+        ! 
+        ! 4. Recherche de l optimum
+        ! -------------------------
+        !
+        IF(ivide.GT.iptx) THEN
+           iii=jni
+           iij=jnj
+           iiii=ipi
+           iijj=ipj
+           iptx=ivide
+           iimoy=imoy
+           zzmin=zmin
+           zzmax=zmax
+           iinf10=inf10
+           iinf30=inf30
+           iinf50=inf50
+           zperx=zper
+        ELSE IF(ivide.EQ.iptx.AND.zperx.LT.zper) THEN
+           iii=jni
+           iij=jnj
+           iiii=ipi
+           iijj=ipj
+           iimoy=imoy
+           zzmin=zmin
+           zzmax=zmax
+           iinf10=inf10
+           iinf30=inf30
+           iinf50=inf50
+           zperx=zper
+        ENDIF
+        !
+        ! 5. Fin de boucle sur le nombre de processeurs
+        ! ---------------------------------------------
+        !
+      1000 continue
+     END DO
+  END DO
+  !
+  !
+  ! 6. Affichage resultat
+  ! ---------------------
+  !
+  IF(in.EQ.0) THEN
+     WRITE(iumout,*) ' le choix n'' a pas pu etre fait '
+     WRITE(iumout,*)
+     WRITE(iumout,*) 'le nombre de processeurs maximum est insuffisant'
+     STOP 
+  ENDIF
+  WRITE(iumout,*) ' choix optimum'
+  WRITE(iumout,*) ' ============='
+  WRITE(iumout,*) 
+  WRITE(iumout,*) '--> nombre de processeurs ',iii*iij
+  WRITE(iumout,*) ' '
+  WRITE(iumout,*) " jpni=",iii ," jpnj=",iij
+  WRITE(iumout,*) " jpi= ",iiii ," jpj= ",iijj
+  WRITE(iumout,*) 
+  WRITE(iumout,*) ' nombre de processeurs mer   ',iii*iij-iptx
+  WRITE(iumout,*) ' nombre de processeurs terre ',iptx
+  WRITE(iumout,*) ' moyenne de recouvrement     ',float(iimoy)/float(iii*iij-iptx)/float(iiii*iijj)
+  WRITE(iumout,*) ' minimum de recouvrement     ',zzmin
+  WRITE(iumout,*) ' maximum de recouvrement     ',zzmax
+  WRITE(iumout,*) ' nb de p recouvrement < 10 % ',iinf10
+  WRITE(iumout,*) ' nb de p      10 < nb < 30 % ',iinf30-iinf10
+  WRITE(iumout,*) ' nb de p      30 < nb < 50 % ',iinf50-iinf10 -iinf30
+  WRITE(iumout,*) ' nombre de points integres   ', (iii*iij-iptx)*iiii*iijj
+  WRITE(iumout,*) ' nbr de pts supplementaires  ', (iii*iij-iptx)*iiii*iijj-jpiglo*jpjglo
+  WRITE(iumout,*) ' % sup                       ',zperx
+  WRITE(iumout,*)
+  CLOSE(iumout)
+  !
+  !
+  !
+  STOP
+END PROGRAM mpp_optimiz_nc
